image: docker:latest

variables:
  DOCKER_DRIVER: overlay2

services:
  - docker:dind

include:
  - template: 'Workflows/MergeRequest-Pipelines.gitlab-ci.yml'

stages:
  - build
  - deploy

build_swirrl_workflow:
  stage: build
  variables:
    SKAFFOLD_DEFAULT_REPO: registry.gitlab.com/knmi-oss/swirrl/swirrl-workflow
  script:
    - apk add curl git
    - docker login -u gitlab-ci-token -p ${CI_JOB_TOKEN} ${CI_REGISTRY}
    - curl -Lo /tmp/skaffold https://storage.googleapis.com/skaffold/releases/latest/skaffold-linux-amd64
    - chmod 700 /tmp/skaffold
    ## TODO: cache-artifacts=false to enforce pre-build hooks to be executed is suboptimal.
    - /tmp/skaffold build -p c4i --file-output=swirrl-workflow-build.json --cache-artifacts=false
  artifacts:
    paths:
      - swirrl-workflow-build.json
      - swirrl-workflow.properties

scan_swirrl-workflow_images:
  stage: deploy
  variables:
    DOWNSTREAM_JOB_NAME: scan_swirrl-workflow_images
    # Cannot use CI_COMMIT_REF_NAME to set UPSTREAM_BRANCH, as it may
    # cause down stream project to not be able to find the artifacts of
    # build_images job in some cases. Gitlab's distinction between
    # branches and branches-with-associated-merge-request is where
    # madness lies.
    UPSTREAM_BRANCH: ${CI_MERGE_REQUEST_REF_PATH}
  trigger:
    project: ${DOWNSTREAM_DEPLOY_PROJECT_NAME}
    # We do not specify a branch, so the default branch will be used
    # in the down stream project.
  rules:
    - if: $CI_COMMIT_REF_NAME != $CI_DEFAULT_BRANCH

deploy-swirrl-workflow-dev:
  stage: deploy
  variables:
    DOWNSTREAM_JOB_NAME: build_swirrl-workflow-images
    # Contrary to the scan job, we do seem to need CI_COMMIT_REF_NAME
    # in the deploy jobs. For the moment, I have no idea why gitlab
    # behaves like this.
    UPSTREAM_BRANCH: ${CI_COMMIT_REF_NAME}
    UPSTREAM_BRANCH_SLUG: ${CI_COMMIT_REF_SLUG}
    DEPLOY_TARGET: dta
  trigger:
    project: ${DOWNSTREAM_DEPLOY_PROJECT_NAME}
    branch: dta
  rules:
    - if: $CI_COMMIT_REF_NAME != $CI_DEFAULT_BRANCH
  when: manual

deploy-swirrl-workflow-prd:
  stage: deploy
  variables:
    DOWNSTREAM_JOB_NAME: build_swirrl-workflow-images
    # See comment in dev job as to why CI_COMMIT_REF_NAME needed here.
    UPSTREAM_BRANCH: ${CI_COMMIT_REF_NAME}
    DEPLOY_TARGET: prd
  trigger:
    project: ${DOWNSTREAM_DEPLOY_PROJECT_NAME}
    # We do not specify a branch, so the default branch will be used
    # in the down stream project.
  rules:
    - if: $CI_COMMIT_REF_NAME == $CI_DEFAULT_BRANCH
  when: manual
